package cn.estsh.i3plus.core.api.iservice.busi;

import cn.estsh.i3plus.pojo.base.bean.ListPager;
import cn.estsh.i3plus.pojo.base.common.Pager;
import cn.estsh.i3plus.pojo.platform.bean.SysDepartment;
import io.swagger.annotations.ApiOperation;

import java.util.List;

/**
 * @Description : 部门业务服务接口
 * @Reference :
 * @Author : yunhao
 * @Date : 2018-10-24 20:39
 * @Modify :
 **/
public interface ISysDepartmentService {

    /**
     * 添加部门
     * @param department
     */
    SysDepartment insertSysDepartment(SysDepartment department);

    /**
     * 根据id删除部门
     * @param id
     */
    void deleteSysDepartmentById(Long id);

    /**
     * 根据id批量删除
     * @param ids id数组
     * @return
     */
    void deleteSysDepartmentByIds(Long[] ids);

    /**
     * 修改部门信息
     * @param department
     */
    void updateSysDepartment(SysDepartment department);

    /**
     * 查询全部部门
     * @return
     */
    List<SysDepartment> listSysDepartment();

    /**
     * 复杂查询
     * @param department
     * @param pager
     * @return
     */
    ListPager<SysDepartment> querySysDepartment(SysDepartment department, Pager pager);

    /**
     * 根据id查询部门
     * @param id
     * @return
     */
    SysDepartment getSysDepartmentById(Long id);

    /**
     * 按条件分页查询部门信息
     * @param department
     * @param pager
     * @return
     */
    ListPager<SysDepartment> findSysDepartmentByPager(SysDepartment department, Pager pager);

    /**
     * 获取部门数量
     * @return
     */
    @ApiOperation(value = "获取部门数量")
    long getSysDepartmentCount();
}
